var gridObject = new Object();

gridObject.options = new Object();

gridObject.options.show = 0;

gridObject.options.hide = 1;

gridObject.options.point = 2;

gridObject.selectedOption = gridObject.options.show;

gridObject.gridSize = 6;

gridObject.width = 0;

gridObject.itemSize = 0;

gridObject.leftOffset = 0;

gridObject.finishGrid = [];

gridObject.finishgridCount = 0;

gridObject.setHtml = function () {
    $(".gridDiv").css({ "width": gridObject.width + "px", "height": gridObject.width + "px" });
    var itemSize = parseInt(gridObject.width / gridObject.gridSize);
    gridObject.itemSize = itemSize;
    var html = "";
    for (var i = 0; i < gridObject.gridSize; i++) {
        for (var j = 0; j < gridObject.gridSize; j++) {
            html += "<div class=\"gridObjectItem\" id=\"gridObjectItem" + (i + 1) + "" + (j + 1) + "\"";
            var BGPosX = itemSize * i;
            var BGPosY = itemSize * j;
            html += " style=\"background-position: -" + BGPosX + "px -" + BGPosY + "px; margin-left: " + BGPosX + "px; margin-top: " + BGPosY + "px;\" ";
            html += "></div>"
        }
    }
    $(".gridDiv").html(html);
    $(".gridObjectItem").css({ "width": itemSize + "px", "height": itemSize + "px" });
    $(".gridObjectItem").css({ "background-size": gridObject.width + "px " + gridObject.width + "px" });
    $(".gridObjectItem").css({ "display": "none" });
}

gridObject.setImage = function (image, finishGrid) {
	if(image.indexOf('url(') >= 0 ){
	    $(".gridObjectItem").css({ "background-image": image });		
	} else {
	    $(".gridObjectItem").css({ "background-image": "url('" + image + "')" });		
	}
    if (gridObject.selectedOption == gridObject.options.hide) {
        $(".gridObjectItem").css({ "display": "" });
    } else if (gridObject.selectedOption == gridObject.options.show) {
        $(".gridObjectItem").css({ "display": "none" });
    } else {
        $(".gridObjectItem").css({ "display": "none" });
        $(".baseAddDiv").css({ "display": "none" });
    }
    this.finishGrid = [];
    for (var i = 0; i < finishGrid.length; i++) {
        this.finishGrid[i] = finishGrid[i];
    }
    this.finishgridCount = 0;
}

gridObject.setLeftOffset = function () {
    gridObject.leftOffset = parseInt($(".gridDiv").css("left"));
}

gridObject.SetGridObject = function () {
    gridObject.width = chooseWidthOrHeight();
    gridObject.setHtml();
}

gridObject.levelFinished = false;

gridObject.showRectTouch = function (left, top) {
    left = left - gridObject.leftOffset;
    var x = parseInt(left / this.itemSize);
    var y = parseInt(top / this.itemSize);
    var xy = (x + 1) + "" + (y + 1);
    var flagSeen = false;
    for (var i = 0; i < gridObject.finishGrid.length; i++) {
        if (gridObject.finishGrid[i] == xy) {
            if (movingToolObject.toolBGPoint != "") {
                movingToolObject.setBackground(movingToolObject.toolBGPoint);
            }
            if (gridObject.selectedOption == gridObject.options.point) {
                flagSeen = true;
            } else {
                gridObject.finishGrid[i] = "-1";
                gridObject.finishgridCount++;
            }
        } else {
            if (movingToolObject.toolBGPoint != "") {
                movingToolObject.setBackground(movingToolObject.toolBG);
            }
        }
    }
    if (gridObject.selectedOption == gridObject.options.point) {
        if (flagSeen) {
            if (movingToolObject.toolBGPoint != "") {
                movingToolObject.setBackground(movingToolObject.toolBGPoint);
            }
        	if(movingToolObject.baseBGPoint != ""){
            	baseObject.setBackgrounds(movingToolObject.baseBGPoint);        		
        	}
            $(".baseAddDiv").css({ "display": "" });
            if (!gridObject.levelFinished) {
                gridObject.levelFinished = true;
                setTimeout("finishLevel()", 3000);
            }
        } else {
        	if(movingToolObject.baseBGPoint != ""){
            	baseObject.setBackgrounds(movingToolObject.baseBG);        		
        	}
            if (movingToolObject.toolBGPoint != "") {
                movingToolObject.setBackground(movingToolObject.toolBG);
            }
            $(".baseAddDiv").css({ "display": "none" });
        }
    }
    if (gridObject.finishgridCount == gridObject.finishGrid.length) {
        if (!gridObject.levelFinished) {
            gridObject.levelFinished = true;
            setTimeout("finishLevel()", 1000);
        }
    }
    var id = "#gridObjectItem" + xy;
    if (gridObject.selectedOption == gridObject.options.hide) {
        $(id).css({ "display": "none" });
    } else if (gridObject.selectedOption == gridObject.options.show) {
        $(id).css({ "display": "" });
    }
}

var baseObject = new Object();

baseObject.setSize = function () {
    $(".baseDiv").css({ "width": gridObject.width + "px", "height": gridObject.width + "px" });
}

baseObject.setBackground = function (bg) {
    $(".baseDiv").css({ "background-image": "url('" + bg + "')" });
}

baseObject.setBackgrounds = function (bg) {
    $(".baseDiv").css({ "background-image": bg });
}

var baseAddObject = new Object();

baseAddObject.setSize = function () {
    $(".baseAddDiv").css({ "width": gridObject.width + "px", "height": gridObject.width + "px" });
}

baseAddObject.setBackground = function (bg) {
	if(bg.indexOf('url(') >= 0 ){
	    $(".baseAddDiv").css({ "background-image": bg });		
	} else {
	    $(".baseAddDiv").css({ "background-image": "url('" + bg + "')" });		
	}
}

var bgObject = new Object();

bgObject.setSize = function () {
    $(".bgDiv").css({ "width": gridObject.width + "px", "height": gridObject.width + "px" });
}

bgObject.setBackground = function (bg) {
    $(".bgDiv").css({ "background-image": "url('" + bg + "')" });
}


function setOnMiddle(arr) {
    if (gridObject.width < window.innerWidth) {
        var diff = window.innerWidth - gridObject.width;
        var diff = parseInt(diff / 2);
        for (var i = 0; i < arr.length; i++) {
            $("." + arr[i]).css({ "left": diff + "px" });
        }
    }
}

function chooseWidthOrHeight() {
    if (window.innerHeight > window.innerWidth) {
        return window.innerWidth;
    }
    return window.innerHeight;
}

function touchFunc(e) {
    var touch = null;
    try {
        touch = e.touches[0] || e.changedTouches[0];
    } catch (e) {
    }
    if (touch == undefined) {
        touch = e;
    }
    var curTop = touch.pageY;
    var curLeft = touch.pageX;
    return { "left": curLeft, "top": curTop };
}

var movingToolObject = new Object();

movingToolObject.move = function (e) {
    e.preventDefault();
    if (levels.isStart == false) {
        return;
    }
    var touch = touchFunc(e);
    if (touch.top > (gridObject.width)) {
        return;
    }
    var fingerOffset = 10;
    $(".MovingTool").css({ "left": (touch.left - fingerOffset) + "px", "top": (touch.top - fingerOffset) + "px" });
    gridObject.showRectTouch((touch.left - fingerOffset), (touch.top - fingerOffset));
}

movingToolObject.setSize = function () {
    var size = parseInt(chooseWidthOrHeight() / 5);
    $(".MovingTool").css({ "background-size": size + "px", "width": size + "px", "height": size + "px" });
}

movingToolObject.hide = function () {
    $(".MovingTool").css({ "display": "none" });
}

movingToolObject.show = function () {
    var left = parseInt(window.innerWidth / 2);
    var top = parseInt(gridObject.width / 2);
    $(".MovingTool").css({ "display": "", "left": left + "px", "top": top + "px" });
}

movingToolObject.toolBG = "";

movingToolObject.toolBGPoint = "";

movingToolObject.setBackground = function (bg) {
    $(".MovingTool").css({ "background-image": "url('" + bg + "')" });
}

var toolsObject = new Object();

toolsObject.objects = [];

toolsObject.size = 0;

toolsObject.setObjects = function (arr) {
    toolsObject.objects = arr;
    this.size = parseInt(chooseWidthOrHeight() / this.objects.length);
    var html = "";
    for (var i = 0; i < this.objects.length; i++) {
        html += "<img class=\"toolsItems\" id=\"toolsItems" + i + "\" src=\"" + this.objects[i] + "\" ontouchstart=\"toolClickForLevel(" + i + ")\" width=\"" + this.size + "\" />";
    }
    $(".tools").html(html);
    $(".tools").css({ "height": this.size + "px" });
    var toolTop = window.innerHeight - this.size;
    if (gridObject.width < toolTop) {
        toolTop = gridObject.width;
    }
    $(".tools").css({ "top": (toolTop - 10) + "px" });
}

toolsObject.opacityObjects = function () {
    $(".toolsItems").css({ "opacity": "0.3" });
    $("#toolsItems" + levels.currentCount).css({ "opacity": "1" });
}

toolsObject.hideSelected = function () {
    $("#toolsItems" + levels.currentCount).css({ "opacity": "0" });
}

function toolClickForLevel(level) {
    if (level == levels.currentCount) {
        levels.isStart = true;
        startLevel();
    }
}

pointsObject = new Object();

pointsObject.currentPoint = 0;

pointsObject.record = 0;

pointsObject.show = function () {
    //$("#points").html(pointsObject.currentPoint);
    $("#record").html(pointsObject.record);
}

pointsObject.getRecord = function () {
    try {
        this.record = JsInterface.GetRecord();
    } catch (ex) {
        try {
            if (localStorage.TopScore) {
                this.record = localStorage.TopScore;
            } else {
                this.record = 0;
            }
        } catch (ex) {

        }
    }
    this.currentPoint = parseInt(this.record);
    pointsObject.show();
}

pointsObject.addPoints = function () {
    this.currentPoint += 1;
    if (this.record < this.currentPoint) {
        this.record = this.currentPoint;
    }
    try {
        JsInterface.SetRecord(this.record);
    } catch (ex) {
        try {
            localStorage.TopScore = this.record;
        } catch (ex) {

        }
    }
    pointsObject.show();
}

function getRandom(start, end) {
    return Math.floor((Math.random() * (end - start + 1)) + start);
}